#ifndef MAIN_H
#define MAIN_H

//****************************************************************************************
//* Main Include File
//*
//* by D. Buergin (daniel.buergin@bluewin.ch)
//****************************************************************************************
//* Revision:
//*
//* 07-07-2006 bue First Version
//****************************************************************************************

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <stdio.h>
#include <stdlib.h>
#include <inttypes.h>
#include <string.h>
#include <util/twi.h>

// #include "datetime.h"
#include "led.h"
#include "uart.h"

#define F_CPU 14745600UL

// Serielle Schnittstelle

#define UART0_BAUD 19200
#define UART1_BAUD 4800

// Some special Characters

#define MAX_CHAR 13
#define CR 13
#define END_OF_RECORD 0x0a

#define MUE     0xe4    // Das Zeichen Mue, 1110|0100
#define GRAD    0xdf    // Das Gradzeichen, 1110|1111
#define STR     0x7c    // Laengstrich    , 0111|1100
#define BLOCK   0xff    // Schwarzer Block, 1111|1111

#if F_CPU == 16000000L
#define OCR_1MS 125
#elif F_CPU == 14745600L
#define OCR_1MS 115
#endif

// Port Befehle
//   Set Portpin to 0

#define CBI(x) _CBI(x)
// #define _XRS(x,y) x &= ~(1<<y)
#define _CBI(x,y) x &= ~(1<<y)

//   Set Portpin to 1

#define SBI(x) _SBI(x)
// #define _XS(x,y) x |= 1<<y
#define _SBI(x,y) x |= 1<<y

// System Timer

volatile uint32_t sys_timer;
volatile uint32_t sec_timer;

// Displaybuffer fuer die Anzeige

char disp_buffer[16];

volatile uint16_t ms_count;

// Funktionsdeklarationen

void ms_sleep(uint16_t);
void init_timer0(void);
void reset_system_timer(void);

#endif
